<template>
  <div class="body">
    <v-row>
      <v-col cols="3" />
      <v-col cols="9" align="center">
        <head-bar title="Sign-In" />
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12" align="center">
        <v-img
          aspect-ratio="1.7778"
          src="http://freedesignfile.com/upload/2016/05/Healthy-eating-logo-design-vector-set-11.jpg"
          height="300px"
          width="300px"
        />
        <v-divider class="ma-6"></v-divider>
      </v-col>
    </v-row>
    <v-form ref="form" v-model="valid" lazy-validation>
      <v-row>
        <v-col cols="1" />
        <v-col cols="5" align="right">
          <v-text-field
            v-model="model.username"
            outlined
            label="Username"
            rules="usernameRules"
          ></v-text-field>
          <v-text-field
            v-model="model.email"
            outlined
            label="Email"
            rules="emailRules"
          ></v-text-field>
          <v-text-field
            v-model="model.phone"
            outlined
            label="Phone"
            rules="phoneRules"
          ></v-text-field>
          <v-col align="center">
            <v-btn
              color="success"
              :disabled="!valid"
              @click="SignIn"
              justify="center"
              >Sign-In</v-btn
            ></v-col
          >
        </v-col>
        <v-col cols="5" align="left">
          <v-text-field
            v-model="model.description"
            outlined
            label="Description"
            rules="descriptionRules"
          ></v-text-field>
          <v-text-field
            v-model="model.password"
            outlined
            label="password"
            rules="passwordRules"
          ></v-text-field>
          <v-text-field
            v-model="model.newConfirm"
            outlined
            required
            label="Confirm new password"
            :rules="confirmRules"
          ></v-text-field>
          <v-col align="center">
            <v-btn color="primary" :disabled="!valid" to="/login"
              >Already has an account</v-btn
            ></v-col
          >
        </v-col>
      </v-row>
    </v-form>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'

export default Vue.extend({
  data() {
    return {
      valid: true,
      model: {
        email: '',
        description: '',
        username: '',
        password: '',
        confirmPassword: '',
        phone: '',
      },
      usernameRules: [(v: string) => !!v || 'Username is required'],
      descriptionRules: [(v: string) => !!v || 'Description is required'],
      phoneRules: [
        (v: string) => !!v || 'Phone number is required',
        (v: string) =>
          /^(?:(?:\+|00)33|0)\s*[1-9](?:[\s.-]*\d{2}){4}$/.test(v) ||
          'Phone number must be valid',
      ],
      emailRules: [(v: string) => !!v || 'Email is required'],
      passwordRules: [(v: string) => !!v || 'This field is required'],
    }
  },
  computed: {
    confirmRules(): Array<any> {
      return [
        (v: string) => !!v || 'This field is required',
        (v: string) =>
          v === this.model.password || 'Password confirmation must match',
      ]
    },
  },
  methods: {
    alertLoginFailed(error: any) {
      const errorNotif = new Notification(error)
    },
    SignIn(): void {
      if ((this.$refs.form as any).validate()) {
        this.$axios
          .post('/signin', {
            email: this.model.email,
            password: this.model.password,
          })
          .then((response) => {
            const accessToken = response.data.accessToken
            const refreshToken = response.data.refreshToken

            this.$store.state.storeAccessTokenInLocalStorage(accessToken)
            this.$store.state.storeRefreshTokenInLocalStorage(refreshToken)
          })
          .catch((error) => {
            this.alertLoginFailed(error)
          })
      }
    },
  },
})
</script>
